from agentspace import Agent, space
#from receiver_client import ReceiverAgent
from receiver_server import ReceiverAgent
from lips import LipsAgent
from pyicubsim import iCubApplicationName, iCubEmotion, iCubHead, iCubLeftArm, iCubRightArm
from speak import speak
import time
import re
import os
import signal

def quit():
    os._exit(0)
    
# exit on ctrl-c
def signal_handler(signal, frame):
    quit()
    
signal.signal(signal.SIGINT, signal_handler)

iCubApplicationName('/listener')

class ListenerAgent(Agent):

    def match(self,pattern,text):
        search = re.search(pattern,text)
        if search is None:
            self.groups = []
            return False
        else:
            self.groups = search.groups()
            return True
    
    def matched(self):
        return self.groups

    def __init__(self,name):
        self.name = name
        super().__init__()
        
    def init(self):
        self.head = iCubHead()
        self.left_arm = iCubLeftArm()
        self.right_arm = iCubRightArm()
        #self.emotion = iCubEmotion()
        space.attach_trigger(self.name,self)
 
    def senseSelectAct(self):
        text = space(default='')[self.name]
        text = text.lower()
        if len(text) > 0:
            print(text)
            if self.match(r'say (.*)',text):
                print(self.matched()[0],'should be said')
                speak(self.matched()[0])
            self.right_arm.set(joint1=85,joint3=40,joint2=40)
            #time.sleep(0.5)
            #self.right_arm.set((0,80,0,50,0,0,0,59,20,20,20,10,10,10,10,10))
            #self.emotions.set('hap')
            
#ReceiverAgent('158.195.28.235',7001,'text') #192.168.0.20 behind router
ReceiverAgent(7171,'text')
LipsAgent('speaking')
ListenerAgent('text')
