# requests would need to be installed: 
# pip install requests
# pip install urllib3
import requests
import urllib
import numpy as np
import cv2
 
# define the URL to our face detection API
service_url = "http://api.pyimagesearch.com/face_detection/detect/"
image_url = "http://dai.fmph.uniba.sk/upload/1/1a/KUZ2009-3.jpg"

# use our face detection API to find faces in images via image URL
payload = {"url": image_url}
r = requests.post(service_url, data=payload).json()
print(r) # this is result of the web service call

# download the image to check
resp = urllib.request.urlopen(image_url)
data = resp.read()
image = np.asarray(bytearray(data), dtype="uint8")
image = cv2.imdecode(image, cv2.IMREAD_COLOR)

# loop over the faces and draw them on the image
for (startX, startY, endX, endY) in r["faces"]:
	cv2.rectangle(image, (startX, startY), (endX, endY), (0, 255, 0), 2)
 
# show the output image
cv2.imshow("faces", image)
cv2.waitKey(0)
 